[tool.poetry]
name = "research-api-template"
version = "0.1.0"
description = "A Cookiecutter template for Research APIs"
authors = ["Research Engineering"]
readme = "README.md"

[tool.poetry.dependencies]
python = "^3.11"

[tool.poetry.group.dev.dependencies]
mypy = "^1.8.0"
pre-commit = "^3.6.1"
pytest = "^8.0.0"
ruff = "^0.3.0"
pytest-cookies = "^0.7.0"

[build-system]
requires = ["poetry-core"]
build-backend = "poetry.core.masonry.api"

[tool.ruff]
line-length = 88
target-version = "py311"
extend-exclude = ['\{\{cookiecutter.project_slug\}\}']

[tool.ruff.lint]
select = [
    "E",   # pycodestyle error
    "W",   # pycodestyle warning
    "F",   # pyflakes
    "I",   # isort
    "PL",  # pylint
    "UP",  # pyupgrade
    "RUF", # ruff
    "C90", # mccabe
    "N",   # PEP 8 naming
    "TRY", # tryceratops
]

[tool.ruff.lint.isort]
combine-as-imports = true
lines-between-types = 1

[tool.mypy]
strict = true
exclude = ['{{cookiecutter.project_slug}}']
